# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/listener/proxy_protocol/v3/proxy_protocol.proto
# plugin: python-betterproto
from dataclasses import dataclass
from typing import List

import betterproto


@dataclass(eq=False, repr=False)
class ProxyProtocol(betterproto.Message):
    rules: List["ProxyProtocolRule"] = betterproto.message_field(1)
    """The list of rules to apply to requests."""

    allow_requests_without_proxy_protocol: bool = betterproto.bool_field(2)
    """
    Allow requests through that don't use proxy protocol. Defaults to false. ..
    attention::   This breaks conformance with the specification.   Only enable
    if ALL traffic to the listener comes from a trusted source.   For more
    information on the security implications of this feature, see
    https://www.haproxy.org/download/2.1/doc/proxy-protocol.txt .. attention::
    Requests of 12 or fewer bytes that match the proxy protocol v2 signature
    and requests of 6 or fewer bytes that match the proxy protocol v1
    signature will timeout (Envoy is unable to differentiate these requests
    from incomplete proxy protocol requests).
    """


@dataclass(eq=False, repr=False)
class ProxyProtocolKeyValuePair(betterproto.Message):
    metadata_namespace: str = betterproto.string_field(1)
    """
    The namespace — if this is empty, the filter's namespace will be used.
    """

    key: str = betterproto.string_field(2)
    """The key to use within the namespace."""


@dataclass(eq=False, repr=False)
class ProxyProtocolRule(betterproto.Message):
    """
    A Rule defines what metadata to apply when a header is present or missing.
    """

    tlv_type: int = betterproto.uint32_field(1)
    """
    The type that triggers the rule - required TLV type is defined as uint8_t
    in proxy protocol. See `the spec
    <https://www.haproxy.org/download/2.1/doc/proxy-protocol.txt>`_ for
    details.
    """

    on_tlv_present: "ProxyProtocolKeyValuePair" = betterproto.message_field(2)
    """If the TLV type is present, apply this metadata KeyValuePair."""
